﻿#region Revision info
/*
 * $Author: clutwopointzero@gmail.com $
 * $Date: 2012-10-01 11:27:38 +0300 (Δευ, 01 Οκτ 2012) $
 * $ID$
 * $Revision: 568 $
 * $URL: http://clu-for-honorbuddy.googlecode.com/svn/trunk/CLU/CLU/Classes/RotationBase.cs $
 * $LastChangedBy: clutwopointzero@gmail.com $
 * $ChangesMade$
 */
#endregion

using Styx;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;

namespace CLU.Classes
{
	public abstract class RotationBase
	{
		protected static LocalPlayer Me
		{
			get { return StyxWoW.Me; }
		}

		protected static WoWUnit Pet
		{
			get { return StyxWoW.Me.Pet; }
		}

	    public abstract string Revision { get; }
        public abstract int KeySpellId { get; }
	    public abstract string KeySpell { get; }

		public abstract Composite SingleRotation { get; }

		public abstract Composite PVPRotation { get; }

		public abstract Composite PVERotation { get; }

        public abstract Composite Pull { get; }

		public abstract Composite Medic { get; }

		public abstract Composite PreCombat { get; }

        //public abstract Composite PVPRotationSelector { get; }

		public abstract Composite Resting { get; }

		public abstract string Name { get; }

		public virtual string Help
		{
			get { return " No help available for this rotation."; }
		}

		// this is used by the moving/facing behavior
		// computed as distance to target's bounding box
		public virtual float CombatMinDistance
		{
			get { return 1f; }
		}

		public virtual float CombatMaxDistance
		{
			get { return 35f; }
		}

	    internal virtual void OnPulse()
        {}
	}
}
